# Retrieve invoices

GET https://api.letsdeel.com/rest/v2/invoices

Retrieve a list of paid invoices for your workforce.
 **Token scopes**: `accounting:read`

Reference: https://developer.deel.com/api/reference/endpoints/accounting/retrieve-invoices

## OpenAPI Specification

```yaml
openapi: 3.1.0
info:
  title: Deel HRIS SCIM API
  version: 1.0.0
paths:
  /invoices:
    get:
      operationId: retrieve-invoices
      summary: Retrieve invoices
      description: |-
        Retrieve a list of paid invoices for your workforce.
         **Token scopes**: `accounting:read`
      tags:
        - subpackage_accounting
      parameters:
        - name: issued_from_date
          in: query
          description: Filter invoices issued on or after the specified date.
          required: false
          schema:
            type: string
        - name: issued_to_date
          in: query
          description: Filter invoices issued before the specified date.
          required: false
          schema:
            type: string
        - name: status
          in: query
          description: >-
            If status query has value of all, all invoices will be returned.
            Otherwise only paid invoices will be fetched.
          required: false
          schema:
            $ref: '#/components/schemas/InvoicesGetParametersStatus'
        - name: limit
          in: query
          description: Number of records to retrieve per page.
          required: false
          schema:
            type: number
            format: double
            default: 25
        - name: offset
          in: query
          description: Index of the first record to return.
          required: false
          schema:
            type: integer
            format: int64
            default: 0
        - name: cursor
          in: query
          description: Return next page of results after the given cursor.
          required: false
          schema:
            type: string
        - name: include
          in: query
          description: Will include invoices from COR workers in the response.
          required: false
          schema:
            $ref: '#/components/schemas/InvoicesGetParametersInclude'
        - name: Authorization
          in: header
          description: >
            ## Authentication

            The Deel API uses bearer tokens to authenticate requests. All API
            calls must be made over HTTPS — calls over plain HTTP or without
            authentication will fail.


            ```curl

            curl -X GET 'https://api.letsdeel.com/rest/v2/contracts' \
              -H 'Authorization: Bearer YOUR-TOKEN-HERE'
            ```


            [Learn more about authentication](/api/authentication)
          required: true
          schema:
            type: string
      responses:
        '200':
          description: Successful operation.
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/Accounting_retrieveInvoices_Response_200'
        '400':
          description: Operation failed.
          content:
            application/json:
              schema:
                type: array
                items:
                  $ref: >-
                    #/components/schemas/InvoicesGetResponsesContentApplicationJsonSchemaItems
        '401':
          description: Operation failed.
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ApiErrorContainer'
        '403':
          description: Operation failed.
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ApiErrorContainer'
        '404':
          description: Operation failed.
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ApiErrorContainer'
        '500':
          description: Operation failed.
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ApiErrorContainer'
servers:
  - url: https://api.letsdeel.com/rest/v2
  - url: https://api-staging.letsdeel.com/rest/v2
components:
  schemas:
    InvoicesGetParametersStatus:
      type: string
      enum:
        - all
      title: InvoicesGetParametersStatus
    InvoicesGetParametersInclude:
      type: string
      enum:
        - cor
      title: InvoicesGetParametersInclude
    InvoicesGetResponsesContentApplicationJsonSchemaDataItemsStatus:
      type: string
      enum:
        - pending
        - paid
        - processing
        - credited
        - refunded
      description: Current status of the invoice.
      title: InvoicesGetResponsesContentApplicationJsonSchemaDataItemsStatus
    InvoicesGetResponsesContentApplicationJsonSchemaDataItemsPaidAt:
      oneOf:
        - type: string
          format: date-time
        - type: string
      description: >-
        Date/time when the invoice was paid (ISO-8601). May be null or empty
        string.
      title: InvoicesGetResponsesContentApplicationJsonSchemaDataItemsPaidAt
    InvoicesGetResponsesContentApplicationJsonSchemaDataItems:
      type: object
      properties:
        id:
          type: string
          description: Unique identifier of this resource.
        label:
          type: string
          description: Label or reference number of the invoice.
        total:
          type: string
          description: Total invoice amount, including fees and VAT.
        amount:
          type:
            - string
            - 'null'
          description: Billed amount of the invoice.
        status:
          $ref: >-
            #/components/schemas/InvoicesGetResponsesContentApplicationJsonSchemaDataItemsStatus
          description: Current status of the invoice.
        vat_id:
          type:
            - string
            - 'null'
          description: VAT identification number related to the invoice.
        paid_at:
          $ref: >-
            #/components/schemas/InvoicesGetResponsesContentApplicationJsonSchemaDataItemsPaidAt
          description: >-
            Date/time when the invoice was paid (ISO-8601). May be null or empty
            string.
        currency:
          type: string
          description: Three-letter currency code for the invoice.
        deel_fee:
          type:
            - string
            - 'null'
          description: Fee charged by Deel.
        due_date:
          type:
            - string
            - 'null'
          format: date-time
          description: Date and time when the invoice is due (ISO-8601 format).
        issued_at:
          type:
            - string
            - 'null'
          format: date-time
          description: Date and time when the invoice was issued (ISO-8601 format).
        vat_total:
          type:
            - string
            - 'null'
          description: Total amount of VAT charged on the invoice.
        created_at:
          type: string
          format: date-time
          description: Date and time when the invoice was created (ISO-8601 format).
        is_overdue:
          type:
            - boolean
            - 'null'
          description: Indicates whether the invoice is overdue.
        contract_id:
          type:
            - string
            - 'null'
          description: Unique identifier of the related contract.
        vat_percentage:
          type:
            - string
            - 'null'
          description: Percentage of VAT charged on the invoice.
        recipient_legal_entity_id:
          type: string
          format: uuid
          description: Unique identifier for the recipient legal entity
      required:
        - id
        - label
        - total
        - status
        - vat_id
        - paid_at
        - currency
        - due_date
        - issued_at
        - vat_total
        - created_at
        - is_overdue
        - contract_id
        - vat_percentage
      title: InvoicesGetResponsesContentApplicationJsonSchemaDataItems
    InvoicesGetResponsesContentApplicationJsonSchemaPage:
      type: object
      properties:
        cursor:
          type:
            - string
            - 'null'
          description: Cursor for paginated results.
        offset:
          type: number
          format: double
          description: The starting position of the current page of results.
        total_rows:
          type: number
          format: double
          description: Total number of rows available for the query.
        items_per_page:
          type: number
          format: double
          description: Number of items displayed per page.
      required:
        - offset
        - total_rows
        - items_per_page
      title: InvoicesGetResponsesContentApplicationJsonSchemaPage
    Accounting_retrieveInvoices_Response_200:
      type: object
      properties:
        data:
          type: array
          items:
            $ref: >-
              #/components/schemas/InvoicesGetResponsesContentApplicationJsonSchemaDataItems
        page:
          $ref: >-
            #/components/schemas/InvoicesGetResponsesContentApplicationJsonSchemaPage
      required:
        - data
        - page
      title: Accounting_retrieveInvoices_Response_200
    InvoicesGetResponsesContentApplicationJsonSchemaItems:
      type: object
      properties:
        code:
          type: string
          description: Machine readable error
        message:
          type: string
          description: Description of the returned error
      title: InvoicesGetResponsesContentApplicationJsonSchemaItems
    ApiErrorRequest:
      type: object
      properties:
        method:
          type: string
          description: The HTTP method of the failed request
        url:
          type: string
          description: The relative URL of the failed request
        status:
          type: number
          format: double
          description: The status code of the response
        api_req_id:
          type: string
          description: The request ID of the failed request
        docs:
          type: string
          description: >-
            A link to the official documentation for the requested endpoint
            resource
        source:
          type: string
          description: The source handler which produced the returned error
        code:
          type: number
          format: double
          description: The code of the source handler which produced the returned error
      title: ApiErrorRequest
    ApiError:
      type: object
      properties:
        message:
          type: string
          description: A description of the returned error
        path:
          type: string
          description: The JSON path where input validation failed
      title: ApiError
    ApiErrorContainer:
      type: object
      properties:
        request:
          $ref: '#/components/schemas/ApiErrorRequest'
        errors:
          type: array
          items:
            $ref: '#/components/schemas/ApiError'
      title: ApiErrorContainer
  securitySchemes:
    deelToken:
      type: http
      scheme: bearer
      description: >
        ## Authentication

        The Deel API uses bearer tokens to authenticate requests. All API calls
        must be made over HTTPS — calls over plain HTTP or without
        authentication will fail.


        ```curl

        curl -X GET 'https://api.letsdeel.com/rest/v2/contracts' \
          -H 'Authorization: Bearer YOUR-TOKEN-HERE'
        ```


        [Learn more about authentication](/api/authentication)
    oauth2:
      type: http
      scheme: bearer
      description: >-
        Standard OAuth2 security scheme based on
        https://swagger.io/docs/specification/authentication/

```

## SDK Code Examples

```python
import requests

url = "https://api.letsdeel.com/rest/v2/invoices"

querystring = {"issued_from_date":"2022-05-24","issued_to_date":"2022-05-24","status":"all","limit":"10","offset":"0","cursor":"GqaY5BHQJUAM2Jg9kq2j2","include":"cor"}

headers = {"Authorization": "Bearer <token>"}

response = requests.get(url, headers=headers, params=querystring)

print(response.json())
```

```javascript
const url = 'https://api.letsdeel.com/rest/v2/invoices?issued_from_date=2022-05-24&issued_to_date=2022-05-24&status=all&limit=10&offset=0&cursor=GqaY5BHQJUAM2Jg9kq2j2&include=cor';
const options = {method: 'GET', headers: {Authorization: 'Bearer <token>'}};

try {
  const response = await fetch(url, options);
  const data = await response.json();
  console.log(data);
} catch (error) {
  console.error(error);
}
```

```go
package main

import (
	"fmt"
	"net/http"
	"io"
)

func main() {

	url := "https://api.letsdeel.com/rest/v2/invoices?issued_from_date=2022-05-24&issued_to_date=2022-05-24&status=all&limit=10&offset=0&cursor=GqaY5BHQJUAM2Jg9kq2j2&include=cor"

	req, _ := http.NewRequest("GET", url, nil)

	req.Header.Add("Authorization", "Bearer <token>")

	res, _ := http.DefaultClient.Do(req)

	defer res.Body.Close()
	body, _ := io.ReadAll(res.Body)

	fmt.Println(res)
	fmt.Println(string(body))

}
```

```ruby
require 'uri'
require 'net/http'

url = URI("https://api.letsdeel.com/rest/v2/invoices?issued_from_date=2022-05-24&issued_to_date=2022-05-24&status=all&limit=10&offset=0&cursor=GqaY5BHQJUAM2Jg9kq2j2&include=cor")

http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true

request = Net::HTTP::Get.new(url)
request["Authorization"] = 'Bearer <token>'

response = http.request(request)
puts response.read_body
```

```java
import com.mashape.unirest.http.HttpResponse;
import com.mashape.unirest.http.Unirest;

HttpResponse<String> response = Unirest.get("https://api.letsdeel.com/rest/v2/invoices?issued_from_date=2022-05-24&issued_to_date=2022-05-24&status=all&limit=10&offset=0&cursor=GqaY5BHQJUAM2Jg9kq2j2&include=cor")
  .header("Authorization", "Bearer <token>")
  .asString();
```

```php
<?php
require_once('vendor/autoload.php');

$client = new \GuzzleHttp\Client();

$response = $client->request('GET', 'https://api.letsdeel.com/rest/v2/invoices?issued_from_date=2022-05-24&issued_to_date=2022-05-24&status=all&limit=10&offset=0&cursor=GqaY5BHQJUAM2Jg9kq2j2&include=cor', [
  'headers' => [
    'Authorization' => 'Bearer <token>',
  ],
]);

echo $response->getBody();
```

```csharp
using RestSharp;

var client = new RestClient("https://api.letsdeel.com/rest/v2/invoices?issued_from_date=2022-05-24&issued_to_date=2022-05-24&status=all&limit=10&offset=0&cursor=GqaY5BHQJUAM2Jg9kq2j2&include=cor");
var request = new RestRequest(Method.GET);
request.AddHeader("Authorization", "Bearer <token>");
IRestResponse response = client.Execute(request);
```

```swift
import Foundation

let headers = ["Authorization": "Bearer <token>"]

let request = NSMutableURLRequest(url: NSURL(string: "https://api.letsdeel.com/rest/v2/invoices?issued_from_date=2022-05-24&issued_to_date=2022-05-24&status=all&limit=10&offset=0&cursor=GqaY5BHQJUAM2Jg9kq2j2&include=cor")! as URL,
                                        cachePolicy: .useProtocolCachePolicy,
                                    timeoutInterval: 10.0)
request.httpMethod = "GET"
request.allHTTPHeaderFields = headers

let session = URLSession.shared
let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in
  if (error != nil) {
    print(error as Any)
  } else {
    let httpResponse = response as? HTTPURLResponse
    print(httpResponse)
  }
})

dataTask.resume()
```